import wavefunctions
def FFST1_1(F2, S3, T4, COUP, M1, W1):
    F1 = wavefunctions.WaveFunction(size=6)
    F1[4] = F2[4]+S3[1]+T4[16]
    F1[5] = F2[5]+S3[2]+T4[17]
    P1 = [complex(F1[4]).real, \
             complex(F1[5]).real, \
             complex(F1[5]).imag, \
             complex(F1[4]).imag]
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    F1[0]= COUP*denom*(S3[0]*( (F2[3]*( (P1[1]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P1[2]*( -T4[0]+T4[5]+T4[10]+T4[15]))))+( (F2[2]*( (P1[0]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P1[3]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))))+(M1*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15])*F2[0]))))
    F1[1]= COUP*denom*(S3[0]*( (F2[2]*( (P1[1]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P1[2]*( T4[0]-T4[5]-T4[10]-T4[15]))))+( (F2[3]*( (P1[0]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P1[3]*( -1j*T4[0]+1j*T4[5]+1j*T4[10]+1j*T4[15]))))+(M1*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15])*F2[1]))))
    F1[2]= COUP*denom*(S3[0]*( (F2[1]*( (P1[1]*( -1j*T4[0]+1j*T4[5]+1j*T4[10]+1j*T4[15]))+(P1[2]*( T4[0]-T4[5]-T4[10]-T4[15]))))+( (F2[0]*( (P1[0]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P1[3]*( -1j*T4[0]+1j*T4[5]+1j*T4[10]+1j*T4[15]))))+(M1*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15])*F2[2]))))
    F1[3]= COUP*denom*(S3[0]*( (F2[0]*( (P1[1]*( -1j*T4[0]+1j*T4[5]+1j*T4[10]+1j*T4[15]))+(P1[2]*( -T4[0]+T4[5]+T4[10]+T4[15]))))+( (F2[1]*( (P1[0]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P1[3]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))))+(M1*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15])*F2[3]))))
    return F1
    
    