import wavefunctions
def FFST1_2(F1, S3, T4, COUP, M2, W2):
    F2 = wavefunctions.WaveFunction(size=6)
    F2[4] = F1[4]-S3[1]-T4[16]
    F2[5] = F1[5]-S3[2]-T4[17]
    P2 = [complex(F2[4]).real, \
             complex(F2[5]).real, \
             complex(F2[5]).imag, \
             complex(F2[4]).imag]
    denom =1.0/(( (M2*( -M2+1j*W2))+( (P2[0]**2)-(P2[1]**2)-(P2[2]**2)-(P2[3]**2))))
    F2[0]= COUP*denom*(S3[0]*( (F1[3]*( (P2[1]*( -1j*T4[0]+1j*T4[5]+1j*T4[10]+1j*T4[15]))+(P2[2]*( -T4[0]+T4[5]+T4[10]+T4[15]))))+( (F1[2]*( (P2[0]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P2[3]*( -1j*T4[0]+1j*T4[5]+1j*T4[10]+1j*T4[15]))))+(M2*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15])*F1[0]))))
    F2[1]= COUP*denom*(S3[0]*( (F1[2]*( (P2[1]*( -1j*T4[0]+1j*T4[5]+1j*T4[10]+1j*T4[15]))+(P2[2]*( T4[0]-T4[5]-T4[10]-T4[15]))))+( (F1[3]*( (P2[0]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P2[3]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))))+(M2*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15])*F1[1]))))
    F2[2]= COUP*denom*(S3[0]*( (F1[1]*( (P2[1]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P2[2]*( T4[0]-T4[5]-T4[10]-T4[15]))))+( (F1[0]*( (P2[0]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P2[3]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))))+(M2*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15])*F1[2]))))
    F2[3]= COUP*denom*(S3[0]*( (F1[0]*( (P2[1]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P2[2]*( -T4[0]+T4[5]+T4[10]+T4[15]))))+( (F1[1]*( (P2[0]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15]))+(P2[3]*( -1j*T4[0]+1j*T4[5]+1j*T4[10]+1j*T4[15]))))+(M2*( 1j*T4[0]-1j*T4[5]-1j*T4[10]-1j*T4[15])*F1[3]))))
    return F2
    
    