import wavefunctions
def FFT2_1(F2, T3, COUP, M1, W1):
    F1 = wavefunctions.WaveFunction(size=6)
    F1[4] = F2[4]+T3[16]
    F1[5] = F2[5]+T3[17]
    P1 = [complex(F1[4]).real, \
             complex(F1[5]).real, \
             complex(F1[5]).imag, \
             complex(F1[4]).imag]
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    F1[0]= COUP*denom*( (F2[3]*( (P1[1]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P1[2]*( -T3[0]+T3[5]+T3[10]+T3[15]))))+( (F2[2]*( (P1[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P1[3]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))))+(M1*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15])*F2[0])))
    F1[1]= COUP*denom*( (F2[2]*( (P1[1]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P1[2]*( T3[0]-T3[5]-T3[10]-T3[15]))))+( (F2[3]*( (P1[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P1[3]*( -1j*T3[0]+1j*T3[5]+1j*T3[10]+1j*T3[15]))))+(M1*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15])*F2[1])))
    F1[2]= COUP*denom*( (F2[1]*( (P1[1]*( -1j*T3[0]+1j*T3[5]+1j*T3[10]+1j*T3[15]))+(P1[2]*( T3[0]-T3[5]-T3[10]-T3[15]))))+( (F2[0]*( (P1[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P1[3]*( -1j*T3[0]+1j*T3[5]+1j*T3[10]+1j*T3[15]))))+(M1*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15])*F2[2])))
    F1[3]= COUP*denom*( (F2[0]*( (P1[1]*( -1j*T3[0]+1j*T3[5]+1j*T3[10]+1j*T3[15]))+(P1[2]*( -T3[0]+T3[5]+T3[10]+T3[15]))))+( (F2[1]*( (P1[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P1[3]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))))+(M1*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15])*F2[3])))
    return F1
    
    