import wavefunctions
def FFT2_2(F1, T3, COUP, M2, W2):
    F2 = wavefunctions.WaveFunction(size=6)
    F2[4] = F1[4]-T3[16]
    F2[5] = F1[5]-T3[17]
    P2 = [complex(F2[4]).real, \
             complex(F2[5]).real, \
             complex(F2[5]).imag, \
             complex(F2[4]).imag]
    denom =1.0/(( (M2*( -M2+1j*W2))+( (P2[0]**2)-(P2[1]**2)-(P2[2]**2)-(P2[3]**2))))
    F2[0]= COUP*denom*( (F1[3]*( (P2[1]*( -1j*T3[0]+1j*T3[5]+1j*T3[10]+1j*T3[15]))+(P2[2]*( -T3[0]+T3[5]+T3[10]+T3[15]))))+( (F1[2]*( (P2[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P2[3]*( -1j*T3[0]+1j*T3[5]+1j*T3[10]+1j*T3[15]))))+(M2*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15])*F1[0])))
    F2[1]= COUP*denom*( (F1[2]*( (P2[1]*( -1j*T3[0]+1j*T3[5]+1j*T3[10]+1j*T3[15]))+(P2[2]*( T3[0]-T3[5]-T3[10]-T3[15]))))+( (F1[3]*( (P2[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P2[3]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))))+(M2*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15])*F1[1])))
    F2[2]= COUP*denom*( (F1[1]*( (P2[1]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P2[2]*( T3[0]-T3[5]-T3[10]-T3[15]))))+( (F1[0]*( (P2[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P2[3]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))))+(M2*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15])*F1[2])))
    F2[3]= COUP*denom*( (F1[0]*( (P2[1]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P2[2]*( -T3[0]+T3[5]+T3[10]+T3[15]))))+( (F1[1]*( (P2[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))+(P2[3]*( -1j*T3[0]+1j*T3[5]+1j*T3[10]+1j*T3[15]))))+(M2*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15])*F1[3])))
    return F2
    
    