import wavefunctions
def FFV4_1(F2, V3, COUP, M1, W1):
    F1 = wavefunctions.WaveFunction(size=6)
    F1[4] = F2[4]+V3[4]
    F1[5] = F2[5]+V3[5]
    P1 = [complex(F1[4]).real, \
             complex(F1[5]).real, \
             complex(F1[5]).imag, \
             complex(F1[4]).imag]
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    F1[0]= COUP*denom*( (F2[0]*( (P1[0]*( 2j*V3[0]-2j*V3[3]))+( (P1[1]*( -2j*V3[1]+(-2+0j)*V3[2]))+( (P1[2]*( (2+0j)*V3[1]-2j*V3[2]))+(P1[3]*( 2j*V3[0]-2j*V3[3]))))))+( (F2[1]*( (P1[0]*( -2j*V3[1]+(2+0j)*V3[2]))+( (P1[1]*( 2j*V3[0]+2j*V3[3]))+( (P1[2]*( (-2+0j)*V3[0]+(-2+0j)*V3[3]))+(P1[3]*( -2j*V3[1]+(2+0j)*V3[2]))))))+(M1*( (F2[2]*( 1j*V3[0]+1j*V3[3]))+(F2[3]*( 1j*V3[1]-V3[2]))))))
    F1[1]= COUP*denom*( (F2[0]*( (P1[0]*( -2j*V3[1]+(-2+0j)*V3[2]))+( (P1[1]*( 2j*V3[0]-2j*V3[3]))+( (P1[2]*( (2+0j)*V3[0]+(-2+0j)*V3[3]))+(P1[3]*( 2j*V3[1]+(2+0j)*V3[2]))))))+( (F2[1]*( (P1[0]*( 2j*V3[0]+2j*V3[3]))+( (P1[1]*( -2j*V3[1]+(2+0j)*V3[2]))+( (P1[2]*( (-2+0j)*V3[1]-2j*V3[2]))+(P1[3]*( -2j*V3[0]-2j*V3[3]))))))+(M1*( (F2[2]*( 1j*V3[1]+V3[2]))+(F2[3]*( 1j*V3[0]-1j*V3[3]))))))
    F1[2]= COUP*denom*( (F2[2]*( (P1[0]*( 1j*V3[0]+1j*V3[3]))+( (P1[1]*( -1j*V3[1]-V3[2]))+( (P1[2]*( V3[1]-1j*V3[2]))+(P1[3]*( -1j*V3[0]-1j*V3[3]))))))+( (F2[3]*( (P1[0]*( 1j*V3[1]-V3[2]))+( (P1[1]*( -1j*V3[0]+1j*V3[3]))+( (P1[2]*( V3[0]-V3[3]))+(P1[3]*( -1j*V3[1]+V3[2]))))))+(M1*( (F2[0]*( 2j*V3[0]-2j*V3[3]))+(F2[1]*( -2j*V3[1]+(2+0j)*V3[2]))))))
    F1[3]= COUP*denom*( (F2[2]*( (P1[0]*( 1j*V3[1]+V3[2]))+( (P1[1]*( -1j*V3[0]-1j*V3[3]))+( (P1[2]*( -V3[0]-V3[3]))+(P1[3]*( 1j*V3[1]+V3[2]))))))+( (F2[3]*( (P1[0]*( 1j*V3[0]-1j*V3[3]))+( (P1[1]*( -1j*V3[1]+V3[2]))+( (P1[2]*( -V3[1]-1j*V3[2]))+(P1[3]*( 1j*V3[0]-1j*V3[3]))))))+(M1*( (F2[0]*( -2j*V3[1]+(-2+0j)*V3[2]))+(F2[1]*( 2j*V3[0]+2j*V3[3]))))))
    return F1
    
    