import wavefunctions
def SST1_1(S2, T3, COUP, M1, W1):
    S1 = wavefunctions.WaveFunction(size=3)
    S1[1] = S2[1]+T3[16]
    S1[2] = S2[2]+T3[17]
    P1 = [-complex(S1[1]).real, \
            - complex(S1[2]).real, \
            - complex(S1[2]).imag, \
            - complex(S1[1]).imag]
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    S1[0]= COUP*denom*(S2[0]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]-1j*T3[15]))
    return S1
    
    
def SST1_2(S2, T3, COUP, M1, W1):
    return SST1_1(S2,T3,COUP,M1,W1)
