import wavefunctions
def VVS1_1(V2, S3, COUP, M1, W1):
    V1 = wavefunctions.WaveFunction(size=6)
    V1[4] = V2[4]+S3[1]
    V1[5] = V2[5]+S3[2]
    P1 = [-complex(V1[4]).real, \
            - complex(V1[5]).real, \
            - complex(V1[5]).imag, \
            - complex(V1[4]).imag]
    OM1 = 0.0
    if (M1): OM1=1.0/M1**2
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    V1[0]= COUP*denom*(S3[0]*( (OM1*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[2]*P1[2])-1j*(V2[3]*P1[3]))*P1[0])-1j*V2[0]))
    V1[1]= COUP*denom*(S3[0]*( (OM1*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[2]*P1[2])-1j*(V2[3]*P1[3]))*P1[1])-1j*V2[1]))
    V1[2]= COUP*denom*(S3[0]*( (OM1*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[2]*P1[2])-1j*(V2[3]*P1[3]))*P1[2])-1j*V2[2]))
    V1[3]= COUP*denom*(S3[0]*( (OM1*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[2]*P1[2])-1j*(V2[3]*P1[3]))*P1[3])-1j*V2[3]))
    return V1
    
    
def VVS1_2(V2, S3, COUP, M1, W1):
    return VVS1_1(V2,S3,COUP,M1,W1)
