import wavefunctions
def FFV1_3(F1, F2, COUP, M3, W3):
    V3 = wavefunctions.WaveFunction(size=6)
    V3[4] = -F1[4]+F2[4]
    V3[5] = -F1[5]+F2[5]
    P3 = [-complex(V3[4]).real, \
            - complex(V3[5]).real, \
            - complex(V3[5]).imag, \
            - complex(V3[4]).imag]
    OM3 = 0.0
    if (M3): OM3=1.0/M3**2
    denom =1.0/(( (M3*( -M3+1j*W3))+( (P3[0]**2)-(P3[1]**2)-(P3[2]**2)-(P3[3]**2))))
    V3[0]= COUP*denom*( (OM3*( (F1[0]*( (F2[3]*( 1j*P3[1]-P3[2]))+(F2[2]*( 1j*P3[0]+1j*P3[3]))))+( (F1[1]*( (F2[2]*( 1j*P3[1]+P3[2]))+(F2[3]*( 1j*P3[0]-1j*P3[3]))))+( (F1[2]*( (F2[1]*( -1j*P3[1]+P3[2]))+(F2[0]*( 1j*P3[0]-1j*P3[3]))))+(F1[3]*( (F2[0]*( -1j*P3[1]-P3[2]))+(F2[1]*( 1j*P3[0]+1j*P3[3])))))))*P3[0])+( -1j*(F2[2]*F1[0])-1j*(F2[3]*F1[1])-1j*(F2[0]*F1[2])-1j*(F2[1]*F1[3])))
    V3[1]= COUP*denom*( (OM3*( (F1[0]*( (F2[3]*( 1j*P3[1]-P3[2]))+(F2[2]*( 1j*P3[0]+1j*P3[3]))))+( (F1[1]*( (F2[2]*( 1j*P3[1]+P3[2]))+(F2[3]*( 1j*P3[0]-1j*P3[3]))))+( (F1[2]*( (F2[1]*( -1j*P3[1]+P3[2]))+(F2[0]*( 1j*P3[0]-1j*P3[3]))))+(F1[3]*( (F2[0]*( -1j*P3[1]-P3[2]))+(F2[1]*( 1j*P3[0]+1j*P3[3])))))))*P3[1])+( 1j*(F2[3]*F1[0])+1j*(F2[2]*F1[1])+(-0-1j)*(F2[1]*F1[2])+(-0-1j)*(F2[0]*F1[3])))
    V3[2]= COUP*denom*( (OM3*( (F1[0]*( (F2[3]*( 1j*P3[1]-P3[2]))+(F2[2]*( 1j*P3[0]+1j*P3[3]))))+( (F1[1]*( (F2[2]*( 1j*P3[1]+P3[2]))+(F2[3]*( 1j*P3[0]-1j*P3[3]))))+( (F1[2]*( (F2[1]*( -1j*P3[1]+P3[2]))+(F2[0]*( 1j*P3[0]-1j*P3[3]))))+(F1[3]*( (F2[0]*( -1j*P3[1]-P3[2]))+(F2[1]*( 1j*P3[0]+1j*P3[3])))))))*P3[2])+( -(F2[3]*F1[0])+(F2[2]*F1[1])+(F2[1]*F1[2])-(F2[0]*F1[3])))
    V3[3]= COUP*denom*( (OM3*( (F1[0]*( (F2[3]*( 1j*P3[1]-P3[2]))+(F2[2]*( 1j*P3[0]+1j*P3[3]))))+( (F1[1]*( (F2[2]*( 1j*P3[1]+P3[2]))+(F2[3]*( 1j*P3[0]-1j*P3[3]))))+( (F1[2]*( (F2[1]*( -1j*P3[1]+P3[2]))+(F2[0]*( 1j*P3[0]-1j*P3[3]))))+(F1[3]*( (F2[0]*( -1j*P3[1]-P3[2]))+(F2[1]*( 1j*P3[0]+1j*P3[3])))))))*P3[3])+( 1j*(F2[2]*F1[0])+(-0-1j)*(F2[3]*F1[1])+(-0-1j)*(F2[0]*F1[2])+1j*(F2[1]*F1[3])))
    return V3
    
    