import wavefunctions
def VSS1_1(S2, S3, COUP, M1, W1):
    V1 = wavefunctions.WaveFunction(size=6)
    V1[4] = S2[1]+S3[1]
    V1[5] = S2[2]+S3[2]
    P2 = [complex(S2[1]).real, \
             complex(S2[2]).real, \
             complex(S2[2]).imag, \
             complex(S2[1]).imag]
    P3 = [complex(S3[1]).real, \
             complex(S3[2]).real, \
             complex(S3[2]).imag, \
             complex(S3[1]).imag]
    P1 = [-complex(V1[4]).real, \
            - complex(V1[5]).real, \
            - complex(V1[5]).imag, \
            - complex(V1[4]).imag]
    OM1 = 0.0
    if (M1): OM1=1.0/M1**2
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    V1[0]= COUP*denom*(S2[0]*( (OM1*( (P1[0]*( -1j*P3[0]+1j*P2[0]))+( (P1[1]*( 1j*P3[1]-1j*P2[1]))+( (P1[2]*( 1j*P3[2]-1j*P2[2]))+(P1[3]*( 1j*P3[3]-1j*P2[3])))))*P1[0])+( -1j*P2[0]+1j*P3[0]))*S3[0])
    V1[1]= COUP*denom*(S2[0]*( (OM1*( (P1[0]*( -1j*P3[0]+1j*P2[0]))+( (P1[1]*( 1j*P3[1]-1j*P2[1]))+( (P1[2]*( 1j*P3[2]-1j*P2[2]))+(P1[3]*( 1j*P3[3]-1j*P2[3])))))*P1[1])+( -1j*P2[1]+1j*P3[1]))*S3[0])
    V1[2]= COUP*denom*(S2[0]*( (OM1*( (P1[0]*( -1j*P3[0]+1j*P2[0]))+( (P1[1]*( 1j*P3[1]-1j*P2[1]))+( (P1[2]*( 1j*P3[2]-1j*P2[2]))+(P1[3]*( 1j*P3[3]-1j*P2[3])))))*P1[2])+( -1j*P2[2]+1j*P3[2]))*S3[0])
    V1[3]= COUP*denom*(S2[0]*( (OM1*( (P1[0]*( -1j*P3[0]+1j*P2[0]))+( (P1[1]*( 1j*P3[1]-1j*P2[1]))+( (P1[2]*( 1j*P3[2]-1j*P2[2]))+(P1[3]*( 1j*P3[3]-1j*P2[3])))))*P1[3])+( -1j*P2[3]+1j*P3[3]))*S3[0])
    return V1
    
    