import wavefunctions
def VSS1_2(V1, S3, COUP, M2, W2):
    S2 = wavefunctions.WaveFunction(size=3)
    S2[1] = V1[4]+S3[1]
    S2[2] = V1[5]+S3[2]
    P2 = [-complex(S2[1]).real, \
            - complex(S2[2]).real, \
            - complex(S2[2]).imag, \
            - complex(S2[1]).imag]
    P3 = [complex(S3[1]).real, \
             complex(S3[2]).real, \
             complex(S3[2]).imag, \
             complex(S3[1]).imag]
    denom =1.0/(( (M2*( -M2+1j*W2))+( (P2[0]**2)-(P2[1]**2)-(P2[2]**2)-(P2[3]**2))))
    S2[0]= COUP*denom*(S3[0]*( (V1[0]*( -1j*P3[0]+1j*P2[0]))+( (V1[1]*( 1j*P3[1]-1j*P2[1]))+( (V1[2]*( 1j*P3[2]-1j*P2[2]))+(V1[3]*( 1j*P3[3]-1j*P2[3]))))))
    return S2
    
    