import wavefunctions
def VVV1_1(V2, V3, COUP, M1, W1):
    V1 = wavefunctions.WaveFunction(size=6)
    V1[4] = V2[4]+V3[4]
    V1[5] = V2[5]+V3[5]
    P2 = [complex(V2[4]).real, \
             complex(V2[5]).real, \
             complex(V2[5]).imag, \
             complex(V2[4]).imag]
    P3 = [complex(V3[4]).real, \
             complex(V3[5]).real, \
             complex(V3[5]).imag, \
             complex(V3[4]).imag]
    P1 = [-complex(V1[4]).real, \
            - complex(V1[5]).real, \
            - complex(V1[5]).imag, \
            - complex(V1[4]).imag]
    OM1 = 0.0
    if (M1): OM1=1.0/M1**2
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    V1[0]= COUP*denom*( (OM1*( (V3[0]*( (V2[0]*( (P1[1]*( 1j*P3[1]-1j*P2[1]))+( (P1[2]*( 1j*P3[2]-1j*P2[2]))+(P1[3]*( 1j*P3[3]-1j*P2[3])))))+( (P1[0]*( -1j*(V2[1]*P3[1])-1j*(V2[2]*P3[2])-1j*(V2[3]*P3[3])))+(P2[0]*( 1j*(V2[1]*P1[1])+1j*(V2[2]*P1[2])+1j*(V2[3]*P1[3]))))))+( (V3[1]*( (V2[1]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[2]*( -1j*P3[2]+1j*P2[2]))+(P1[3]*( -1j*P3[3]+1j*P2[3])))))+( (P1[1]*( -1j*(V2[0]*P3[0])+1j*(V2[2]*P3[2])+1j*(V2[3]*P3[3])))+(P2[1]*( 1j*(V2[0]*P1[0])-1j*(V2[2]*P1[2])-1j*(V2[3]*P1[3]))))))+( (V3[2]*( (V2[2]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[1]*( -1j*P3[1]+1j*P2[1]))+(P1[3]*( -1j*P3[3]+1j*P2[3])))))+( (P1[2]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[3]*P3[3])))+(P2[2]*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[3]*P1[3]))))))+(V3[3]*( (V2[3]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[1]*( -1j*P3[1]+1j*P2[1]))+(P1[2]*( -1j*P3[2]+1j*P2[2])))))+( (P1[3]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[2]*P3[2])))+(P2[3]*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[2]*P1[2])))))))))*P1[0])+( (V3[0]*( (V2[1]*( 1j*P3[1]-1j*P1[1]))+( (V2[2]*( 1j*P3[2]-1j*P1[2]))+(V2[3]*( 1j*P3[3]-1j*P1[3])))))+( (V2[0]*( (V3[1]*( -1j*P2[1]+1j*P1[1]))+( (V3[2]*( -1j*P2[2]+1j*P1[2]))+(V3[3]*( -1j*P2[3]+1j*P1[3])))))+( (P3[0]*( -1j*(V3[1]*V2[1])-1j*(V3[2]*V2[2])-1j*(V3[3]*V2[3])))+(P2[0]*( 1j*(V3[1]*V2[1])+1j*(V3[2]*V2[2])+1j*(V3[3]*V2[3])))))))
    V1[1]= COUP*denom*( (OM1*( (V3[0]*( (V2[0]*( (P1[1]*( 1j*P3[1]-1j*P2[1]))+( (P1[2]*( 1j*P3[2]-1j*P2[2]))+(P1[3]*( 1j*P3[3]-1j*P2[3])))))+( (P1[0]*( -1j*(V2[1]*P3[1])-1j*(V2[2]*P3[2])-1j*(V2[3]*P3[3])))+(P2[0]*( 1j*(V2[1]*P1[1])+1j*(V2[2]*P1[2])+1j*(V2[3]*P1[3]))))))+( (V3[1]*( (V2[1]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[2]*( -1j*P3[2]+1j*P2[2]))+(P1[3]*( -1j*P3[3]+1j*P2[3])))))+( (P1[1]*( -1j*(V2[0]*P3[0])+1j*(V2[2]*P3[2])+1j*(V2[3]*P3[3])))+(P2[1]*( 1j*(V2[0]*P1[0])-1j*(V2[2]*P1[2])-1j*(V2[3]*P1[3]))))))+( (V3[2]*( (V2[2]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[1]*( -1j*P3[1]+1j*P2[1]))+(P1[3]*( -1j*P3[3]+1j*P2[3])))))+( (P1[2]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[3]*P3[3])))+(P2[2]*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[3]*P1[3]))))))+(V3[3]*( (V2[3]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[1]*( -1j*P3[1]+1j*P2[1]))+(P1[2]*( -1j*P3[2]+1j*P2[2])))))+( (P1[3]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[2]*P3[2])))+(P2[3]*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[2]*P1[2])))))))))*P1[1])+( (V3[1]*( (V2[0]*( -1j*P3[0]+1j*P1[0]))+( (V2[2]*( 1j*P3[2]-1j*P1[2]))+(V2[3]*( 1j*P3[3]-1j*P1[3])))))+( (V2[1]*( (V3[0]*( 1j*P2[0]-1j*P1[0]))+( (V3[2]*( -1j*P2[2]+1j*P1[2]))+(V3[3]*( -1j*P2[3]+1j*P1[3])))))+( (P3[1]*( 1j*(V3[0]*V2[0])-1j*(V3[2]*V2[2])-1j*(V3[3]*V2[3])))+(P2[1]*( -1j*(V3[0]*V2[0])+1j*(V3[2]*V2[2])+1j*(V3[3]*V2[3])))))))
    V1[2]= COUP*denom*( (OM1*( (V3[0]*( (V2[0]*( (P1[1]*( 1j*P3[1]-1j*P2[1]))+( (P1[2]*( 1j*P3[2]-1j*P2[2]))+(P1[3]*( 1j*P3[3]-1j*P2[3])))))+( (P1[0]*( -1j*(V2[1]*P3[1])-1j*(V2[2]*P3[2])-1j*(V2[3]*P3[3])))+(P2[0]*( 1j*(V2[1]*P1[1])+1j*(V2[2]*P1[2])+1j*(V2[3]*P1[3]))))))+( (V3[1]*( (V2[1]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[2]*( -1j*P3[2]+1j*P2[2]))+(P1[3]*( -1j*P3[3]+1j*P2[3])))))+( (P1[1]*( -1j*(V2[0]*P3[0])+1j*(V2[2]*P3[2])+1j*(V2[3]*P3[3])))+(P2[1]*( 1j*(V2[0]*P1[0])-1j*(V2[2]*P1[2])-1j*(V2[3]*P1[3]))))))+( (V3[2]*( (V2[2]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[1]*( -1j*P3[1]+1j*P2[1]))+(P1[3]*( -1j*P3[3]+1j*P2[3])))))+( (P1[2]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[3]*P3[3])))+(P2[2]*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[3]*P1[3]))))))+(V3[3]*( (V2[3]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[1]*( -1j*P3[1]+1j*P2[1]))+(P1[2]*( -1j*P3[2]+1j*P2[2])))))+( (P1[3]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[2]*P3[2])))+(P2[3]*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[2]*P1[2])))))))))*P1[2])+( (V3[2]*( (V2[0]*( -1j*P3[0]+1j*P1[0]))+( (V2[1]*( 1j*P3[1]-1j*P1[1]))+(V2[3]*( 1j*P3[3]-1j*P1[3])))))+( (V2[2]*( (V3[0]*( 1j*P2[0]-1j*P1[0]))+( (V3[1]*( -1j*P2[1]+1j*P1[1]))+(V3[3]*( -1j*P2[3]+1j*P1[3])))))+( (P3[2]*( 1j*(V3[0]*V2[0])-1j*(V3[1]*V2[1])-1j*(V3[3]*V2[3])))+(P2[2]*( -1j*(V3[0]*V2[0])+1j*(V3[1]*V2[1])+1j*(V3[3]*V2[3])))))))
    V1[3]= COUP*denom*( (OM1*( (V3[0]*( (V2[0]*( (P1[1]*( 1j*P3[1]-1j*P2[1]))+( (P1[2]*( 1j*P3[2]-1j*P2[2]))+(P1[3]*( 1j*P3[3]-1j*P2[3])))))+( (P1[0]*( -1j*(V2[1]*P3[1])-1j*(V2[2]*P3[2])-1j*(V2[3]*P3[3])))+(P2[0]*( 1j*(V2[1]*P1[1])+1j*(V2[2]*P1[2])+1j*(V2[3]*P1[3]))))))+( (V3[1]*( (V2[1]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[2]*( -1j*P3[2]+1j*P2[2]))+(P1[3]*( -1j*P3[3]+1j*P2[3])))))+( (P1[1]*( -1j*(V2[0]*P3[0])+1j*(V2[2]*P3[2])+1j*(V2[3]*P3[3])))+(P2[1]*( 1j*(V2[0]*P1[0])-1j*(V2[2]*P1[2])-1j*(V2[3]*P1[3]))))))+( (V3[2]*( (V2[2]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[1]*( -1j*P3[1]+1j*P2[1]))+(P1[3]*( -1j*P3[3]+1j*P2[3])))))+( (P1[2]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[3]*P3[3])))+(P2[2]*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[3]*P1[3]))))))+(V3[3]*( (V2[3]*( (P1[0]*( 1j*P3[0]-1j*P2[0]))+( (P1[1]*( -1j*P3[1]+1j*P2[1]))+(P1[2]*( -1j*P3[2]+1j*P2[2])))))+( (P1[3]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[2]*P3[2])))+(P2[3]*( 1j*(V2[0]*P1[0])-1j*(V2[1]*P1[1])-1j*(V2[2]*P1[2])))))))))*P1[3])+( (V3[3]*( (V2[0]*( -1j*P3[0]+1j*P1[0]))+( (V2[1]*( 1j*P3[1]-1j*P1[1]))+(V2[2]*( 1j*P3[2]-1j*P1[2])))))+( (V2[3]*( (V3[0]*( 1j*P2[0]-1j*P1[0]))+( (V3[1]*( -1j*P2[1]+1j*P1[1]))+(V3[2]*( -1j*P2[2]+1j*P1[2])))))+( (P3[3]*( 1j*(V3[0]*V2[0])-1j*(V3[1]*V2[1])-1j*(V3[2]*V2[2])))+(P2[3]*( -1j*(V3[0]*V2[0])+1j*(V3[1]*V2[1])+1j*(V3[2]*V2[2])))))))
    return V1
    
    