import wavefunctions
def FFS1_1(F2, S3, COUP, M1, W1):
    F1 = wavefunctions.WaveFunction(size=6)
    F1[4] = F2[4]+S3[1]
    F1[5] = F2[5]+S3[2]
    P1 = [complex(F1[4]).real, \
             complex(F1[5]).real, \
             complex(F1[5]).imag, \
             complex(F1[4]).imag]
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    F1[0]= COUP*denom*(S3[0]*( (F2[3]*( 1j*P1[1]-P1[2]))+( (F2[2]*( 1j*P1[0]+1j*P1[3]))+1j*(F2[0]*M1))))
    F1[1]= COUP*denom*(S3[0]*( (F2[2]*( 1j*P1[1]+P1[2]))+( (F2[3]*( 1j*P1[0]-1j*P1[3]))+1j*(F2[1]*M1))))
    F1[2]= COUP*denom*(S3[0]*( (F2[1]*( -1j*P1[1]+P1[2]))+( (F2[0]*( 1j*P1[0]-1j*P1[3]))+1j*(F2[2]*M1))))
    F1[3]= COUP*denom*(S3[0]*( (F2[0]*( -1j*P1[1]-P1[2]))+( (F2[1]*( 1j*P1[0]+1j*P1[3]))+1j*(F2[3]*M1))))
    return F1
    
    