import wavefunctions
def SST2_1(S2, T3, COUP, M1, W1):
    S1 = wavefunctions.WaveFunction(size=3)
    S1[1] = S2[1]+T3[16]
    S1[2] = S2[2]+T3[17]
    P2 = [complex(S2[1]).real, \
             complex(S2[2]).real, \
             complex(S2[2]).imag, \
             complex(S2[1]).imag]
    P1 = [-complex(S1[1]).real, \
            - complex(S1[2]).real, \
            - complex(S1[2]).imag, \
            - complex(S1[1]).imag]
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    S1[0]= COUP*denom*(S2[0]*( (P2[0]*( (P1[0]*( 1j*T3[5]+1j*T3[10]+1j*T3[15]+1j*T3[0]))+( (P1[1]*( -1j*T3[4]-1j*T3[1]))+( (P1[2]*( -1j*T3[8]-1j*T3[2]))+(P1[3]*( -1j*T3[12]-1j*T3[3]))))))+( (P2[1]*( (P1[1]*( 1j*T3[0]-1j*T3[10]-1j*T3[15]+1j*T3[5]))+( (P1[0]*( -1j*T3[1]-1j*T3[4]))+( (P1[2]*( 1j*T3[9]+1j*T3[6]))+(P1[3]*( 1j*T3[13]+1j*T3[7]))))))+( (P2[2]*( (P1[2]*( 1j*T3[0]-1j*T3[5]-1j*T3[15]+1j*T3[10]))+( (P1[0]*( -1j*T3[2]-1j*T3[8]))+( (P1[1]*( 1j*T3[6]+1j*T3[9]))+(P1[3]*( 1j*T3[14]+1j*T3[11]))))))+(P2[3]*( (P1[3]*( 1j*T3[0]-1j*T3[5]-1j*T3[10]+1j*T3[15]))+( (P1[0]*( -1j*T3[3]-1j*T3[12]))+( (P1[1]*( 1j*T3[7]+1j*T3[13]))+(P1[2]*( 1j*T3[11]+1j*T3[14]))))))))))
    return S1
    
    
def SST2_2(S2, T3, COUP, M1, W1):
    return SST2_1(S2,T3,COUP,M1,W1)
