import wavefunctions
def VVS1_3(V1, V2, COUP, M3, W3):
    S3 = wavefunctions.WaveFunction(size=3)
    S3[1] = V1[4]+V2[4]
    S3[2] = V1[5]+V2[5]
    P3 = [-complex(S3[1]).real, \
            - complex(S3[2]).real, \
            - complex(S3[2]).imag, \
            - complex(S3[1]).imag]
    denom =1.0/(( (M3*( -M3+1j*W3))+( (P3[0]**2)-(P3[1]**2)-(P3[2]**2)-(P3[3]**2))))
    S3[0]= COUP*denom*( 1j*(V2[0]*V1[0])+(-0-1j)*(V2[1]*V1[1])+(-0-1j)*(V2[2]*V1[2])+(-0-1j)*(V2[3]*V1[3]))
    return S3
    
    