import wavefunctions
def VVSST1_3(V1, V2, S4, T5, COUP, M3, W3):
    S3 = wavefunctions.WaveFunction(size=3)
    S3[1] = V1[4]+V2[4]+S4[1]+T5[16]
    S3[2] = V1[5]+V2[5]+S4[2]+T5[17]
    P3 = [-complex(S3[1]).real, \
            - complex(S3[2]).real, \
            - complex(S3[2]).imag, \
            - complex(S3[1]).imag]
    denom =1.0/(( (M3*( -M3+1j*W3))+( (P3[0]**2)-(P3[1]**2)-(P3[2]**2)-(P3[3]**2))))
    S3[0]= COUP*denom*(S4[0]*( (V1[0]*( (V2[0]*( 1j*T5[5]+1j*T5[10]+1j*T5[15]+1j*T5[0]))+( (V2[1]*( -1j*T5[1]-1j*T5[4]))+( (V2[2]*( -1j*T5[2]-1j*T5[8]))+(V2[3]*( -1j*T5[3]-1j*T5[12]))))))+( (V1[1]*( (V2[1]*( 1j*T5[0]-1j*T5[10]-1j*T5[15]+1j*T5[5]))+( (V2[0]*( -1j*T5[4]-1j*T5[1]))+( (V2[2]*( 1j*T5[6]+1j*T5[9]))+(V2[3]*( 1j*T5[7]+1j*T5[13]))))))+( (V1[2]*( (V2[2]*( 1j*T5[0]-1j*T5[5]-1j*T5[15]+1j*T5[10]))+( (V2[0]*( -1j*T5[8]-1j*T5[2]))+( (V2[1]*( 1j*T5[9]+1j*T5[6]))+(V2[3]*( 1j*T5[11]+1j*T5[14]))))))+(V1[3]*( (V2[3]*( 1j*T5[0]-1j*T5[5]-1j*T5[10]+1j*T5[15]))+( (V2[0]*( -1j*T5[12]-1j*T5[3]))+( (V2[1]*( 1j*T5[13]+1j*T5[7]))+(V2[2]*( 1j*T5[14]+1j*T5[11]))))))))))
    return S3
    
    
def VVSST1_4(V1, V2, S4, T5, COUP, M3, W3):
    return VVSST1_3(V1,V2,S4,T5,COUP,M3,W3)
