import wavefunctions
def VVST1_3(V1, V2, T4, COUP, M3, W3):
    S3 = wavefunctions.WaveFunction(size=3)
    S3[1] = V1[4]+V2[4]+T4[16]
    S3[2] = V1[5]+V2[5]+T4[17]
    P3 = [-complex(S3[1]).real, \
            - complex(S3[2]).real, \
            - complex(S3[2]).imag, \
            - complex(S3[1]).imag]
    denom =1.0/(( (M3*( -M3+1j*W3))+( (P3[0]**2)-(P3[1]**2)-(P3[2]**2)-(P3[3]**2))))
    S3[0]= COUP*denom*( (V1[0]*( (V2[0]*( 1j*T4[5]+1j*T4[10]+1j*T4[15]+1j*T4[0]))+( (V2[1]*( -1j*T4[1]-1j*T4[4]))+( (V2[2]*( -1j*T4[2]-1j*T4[8]))+(V2[3]*( -1j*T4[3]-1j*T4[12]))))))+( (V1[1]*( (V2[1]*( 1j*T4[0]-1j*T4[10]-1j*T4[15]+1j*T4[5]))+( (V2[0]*( -1j*T4[4]-1j*T4[1]))+( (V2[2]*( 1j*T4[6]+1j*T4[9]))+(V2[3]*( 1j*T4[7]+1j*T4[13]))))))+( (V1[2]*( (V2[2]*( 1j*T4[0]-1j*T4[5]-1j*T4[15]+1j*T4[10]))+( (V2[0]*( -1j*T4[8]-1j*T4[2]))+( (V2[1]*( 1j*T4[9]+1j*T4[6]))+(V2[3]*( 1j*T4[11]+1j*T4[14]))))))+(V1[3]*( (V2[3]*( 1j*T4[0]-1j*T4[5]-1j*T4[10]+1j*T4[15]))+( (V2[0]*( -1j*T4[12]-1j*T4[3]))+( (V2[1]*( 1j*T4[13]+1j*T4[7]))+(V2[2]*( 1j*T4[14]+1j*T4[11])))))))))
    return S3
    
    