import wavefunctions
def VVT3_1(V2, T3, COUP, M1, W1):
    V1 = wavefunctions.WaveFunction(size=6)
    V1[4] = V2[4]+T3[16]
    V1[5] = V2[5]+T3[17]
    P2 = [complex(V2[4]).real, \
             complex(V2[5]).real, \
             complex(V2[5]).imag, \
             complex(V2[4]).imag]
    P1 = [-complex(V1[4]).real, \
            - complex(V1[5]).real, \
            - complex(V1[5]).imag, \
            - complex(V1[4]).imag]
    OM1 = 0.0
    if (M1): OM1=1.0/M1**2
    denom =1.0/(( (M1*( -M1+1j*W1))+( (P1[0]**2)-(P1[1]**2)-(P1[2]**2)-(P1[3]**2))))
    V1[0]= COUP*denom*( (P2[0]*( (V2[1]*( (P1[1]*( -1j*T3[10]-1j*T3[15]+1j*T3[5]-1j*T3[0]))+( (P1[2]*( 1j*T3[9]+1j*T3[6]))+(P1[3]*( 1j*T3[13]+1j*T3[7])))))+( (V2[2]*( (P1[2]*( -1j*T3[5]-1j*T3[15]+1j*T3[10]-1j*T3[0]))+( (P1[1]*( 1j*T3[6]+1j*T3[9]))+(P1[3]*( 1j*T3[14]+1j*T3[11])))))+(V2[3]*( (P1[3]*( -1j*T3[5]-1j*T3[10]+1j*T3[15]-1j*T3[0]))+( (P1[1]*( 1j*T3[7]+1j*T3[13]))+(P1[2]*( 1j*T3[11]+1j*T3[14]))))))))+( (V2[0]*( (P2[1]*( (P1[1]*( 1j*T3[10]+1j*T3[15]+1j*T3[0]-1j*T3[5]))+( (P1[2]*( -1j*T3[9]-1j*T3[6]))+(P1[3]*( -1j*T3[13]-1j*T3[7])))))+( (P2[2]*( (P1[2]*( 1j*T3[5]+1j*T3[15]+1j*T3[0]-1j*T3[10]))+( (P1[1]*( -1j*T3[6]-1j*T3[9]))+(P1[3]*( -1j*T3[14]-1j*T3[11])))))+(P2[3]*( (P1[3]*( 1j*T3[5]+1j*T3[10]+1j*T3[0]-1j*T3[15]))+( (P1[1]*( -1j*T3[7]-1j*T3[13]))+(P1[2]*( -1j*T3[11]-1j*T3[14]))))))))+( (V2[1]*( (P2[2]*( (P1[2]*( -1j*T3[1]-1j*T3[4]))+(P1[1]*( 1j*T3[8]+1j*T3[2]))))+(P2[3]*( (P1[3]*( -1j*T3[1]-1j*T3[4]))+(P1[1]*( 1j*T3[12]+1j*T3[3]))))))+( (V2[2]*( (P2[1]*( (P1[1]*( -1j*T3[2]-1j*T3[8]))+(P1[2]*( 1j*T3[4]+1j*T3[1]))))+(P2[3]*( (P1[3]*( -1j*T3[2]-1j*T3[8]))+(P1[2]*( 1j*T3[12]+1j*T3[3]))))))+(V2[3]*( (P2[1]*( (P1[1]*( -1j*T3[3]-1j*T3[12]))+(P1[3]*( 1j*T3[4]+1j*T3[1]))))+(P2[2]*( (P1[2]*( -1j*T3[3]-1j*T3[12]))+(P1[3]*( 1j*T3[8]+1j*T3[2]))))))))))
    V1[1]= COUP*denom*( (P2[1]*( (V2[0]*( (P1[0]*( 1j*T3[10]+1j*T3[15]+1j*T3[0]-1j*T3[5]))+( (P1[2]*( -1j*T3[8]-1j*T3[2]))+(P1[3]*( -1j*T3[12]-1j*T3[3])))))+( (V2[2]*( (P1[2]*( 1j*T3[0]-1j*T3[15]+1j*T3[10]+1j*T3[5]))+( (P1[0]*( -1j*T3[2]-1j*T3[8]))+(P1[3]*( 1j*T3[14]+1j*T3[11])))))+(V2[3]*( (P1[3]*( 1j*T3[0]-1j*T3[10]+1j*T3[15]+1j*T3[5]))+( (P1[0]*( -1j*T3[3]-1j*T3[12]))+(P1[2]*( 1j*T3[11]+1j*T3[14]))))))))+( (V2[1]*( (P2[0]*( (P1[0]*( -1j*T3[10]-1j*T3[15]+1j*T3[5]-1j*T3[0]))+( (P1[2]*( 1j*T3[8]+1j*T3[2]))+(P1[3]*( 1j*T3[12]+1j*T3[3])))))+( (P2[2]*( (P1[2]*( -1j*T3[0]+1j*T3[15]-1j*T3[5]-1j*T3[10]))+( (P1[0]*( 1j*T3[2]+1j*T3[8]))+(P1[3]*( -1j*T3[14]-1j*T3[11])))))+(P2[3]*( (P1[3]*( -1j*T3[0]+1j*T3[10]-1j*T3[5]-1j*T3[15]))+( (P1[0]*( 1j*T3[3]+1j*T3[12]))+(P1[2]*( -1j*T3[11]-1j*T3[14]))))))))+( (V2[0]*( (P2[2]*( (P1[2]*( 1j*T3[4]+1j*T3[1]))+(P1[0]*( -1j*T3[9]-1j*T3[6]))))+(P2[3]*( (P1[3]*( 1j*T3[4]+1j*T3[1]))+(P1[0]*( -1j*T3[13]-1j*T3[7]))))))+( (V2[2]*( (P2[0]*( (P1[0]*( 1j*T3[6]+1j*T3[9]))+(P1[2]*( -1j*T3[1]-1j*T3[4]))))+(P2[3]*( (P1[3]*( -1j*T3[6]-1j*T3[9]))+(P1[2]*( 1j*T3[13]+1j*T3[7]))))))+(V2[3]*( (P2[0]*( (P1[0]*( 1j*T3[7]+1j*T3[13]))+(P1[3]*( -1j*T3[1]-1j*T3[4]))))+(P2[2]*( (P1[2]*( -1j*T3[7]-1j*T3[13]))+(P1[3]*( 1j*T3[9]+1j*T3[6]))))))))))
    V1[2]= COUP*denom*( (P2[2]*( (V2[0]*( (P1[0]*( 1j*T3[5]+1j*T3[15]+1j*T3[0]-1j*T3[10]))+( (P1[1]*( -1j*T3[4]-1j*T3[1]))+(P1[3]*( -1j*T3[12]-1j*T3[3])))))+( (V2[1]*( (P1[1]*( 1j*T3[0]-1j*T3[15]+1j*T3[5]+1j*T3[10]))+( (P1[0]*( -1j*T3[1]-1j*T3[4]))+(P1[3]*( 1j*T3[13]+1j*T3[7])))))+(V2[3]*( (P1[3]*( 1j*T3[0]-1j*T3[5]+1j*T3[15]+1j*T3[10]))+( (P1[0]*( -1j*T3[3]-1j*T3[12]))+(P1[1]*( 1j*T3[7]+1j*T3[13]))))))))+( (V2[2]*( (P2[0]*( (P1[0]*( -1j*T3[5]-1j*T3[15]+1j*T3[10]-1j*T3[0]))+( (P1[1]*( 1j*T3[4]+1j*T3[1]))+(P1[3]*( 1j*T3[12]+1j*T3[3])))))+( (P2[1]*( (P1[1]*( -1j*T3[0]+1j*T3[15]-1j*T3[10]-1j*T3[5]))+( (P1[0]*( 1j*T3[1]+1j*T3[4]))+(P1[3]*( -1j*T3[13]-1j*T3[7])))))+(P2[3]*( (P1[3]*( -1j*T3[0]+1j*T3[5]-1j*T3[10]-1j*T3[15]))+( (P1[0]*( 1j*T3[3]+1j*T3[12]))+(P1[1]*( -1j*T3[7]-1j*T3[13]))))))))+( (V2[0]*( (P2[1]*( (P1[1]*( 1j*T3[8]+1j*T3[2]))+(P1[0]*( -1j*T3[6]-1j*T3[9]))))+(P2[3]*( (P1[3]*( 1j*T3[8]+1j*T3[2]))+(P1[0]*( -1j*T3[14]-1j*T3[11]))))))+( (V2[1]*( (P2[0]*( (P1[0]*( 1j*T3[9]+1j*T3[6]))+(P1[1]*( -1j*T3[2]-1j*T3[8]))))+(P2[3]*( (P1[3]*( -1j*T3[9]-1j*T3[6]))+(P1[1]*( 1j*T3[14]+1j*T3[11]))))))+(V2[3]*( (P2[0]*( (P1[0]*( 1j*T3[11]+1j*T3[14]))+(P1[3]*( -1j*T3[2]-1j*T3[8]))))+(P2[1]*( (P1[1]*( -1j*T3[11]-1j*T3[14]))+(P1[3]*( 1j*T3[6]+1j*T3[9]))))))))))
    V1[3]= COUP*denom*( (P2[3]*( (V2[0]*( (P1[0]*( 1j*T3[5]+1j*T3[10]+1j*T3[0]-1j*T3[15]))+( (P1[1]*( -1j*T3[4]-1j*T3[1]))+(P1[2]*( -1j*T3[8]-1j*T3[2])))))+( (V2[1]*( (P1[1]*( 1j*T3[0]-1j*T3[10]+1j*T3[5]+1j*T3[15]))+( (P1[0]*( -1j*T3[1]-1j*T3[4]))+(P1[2]*( 1j*T3[9]+1j*T3[6])))))+(V2[2]*( (P1[2]*( 1j*T3[0]-1j*T3[5]+1j*T3[10]+1j*T3[15]))+( (P1[0]*( -1j*T3[2]-1j*T3[8]))+(P1[1]*( 1j*T3[6]+1j*T3[9]))))))))+( (V2[3]*( (P2[0]*( (P1[0]*( -1j*T3[5]-1j*T3[10]+1j*T3[15]-1j*T3[0]))+( (P1[1]*( 1j*T3[4]+1j*T3[1]))+(P1[2]*( 1j*T3[8]+1j*T3[2])))))+( (P2[1]*( (P1[1]*( -1j*T3[0]+1j*T3[10]-1j*T3[15]-1j*T3[5]))+( (P1[0]*( 1j*T3[1]+1j*T3[4]))+(P1[2]*( -1j*T3[9]-1j*T3[6])))))+(P2[2]*( (P1[2]*( -1j*T3[0]+1j*T3[5]-1j*T3[15]-1j*T3[10]))+( (P1[0]*( 1j*T3[2]+1j*T3[8]))+(P1[1]*( -1j*T3[6]-1j*T3[9]))))))))+( (V2[0]*( (P2[1]*( (P1[1]*( 1j*T3[12]+1j*T3[3]))+(P1[0]*( -1j*T3[7]-1j*T3[13]))))+(P2[2]*( (P1[2]*( 1j*T3[12]+1j*T3[3]))+(P1[0]*( -1j*T3[11]-1j*T3[14]))))))+( (V2[1]*( (P2[0]*( (P1[0]*( 1j*T3[13]+1j*T3[7]))+(P1[1]*( -1j*T3[3]-1j*T3[12]))))+(P2[2]*( (P1[2]*( -1j*T3[13]-1j*T3[7]))+(P1[1]*( 1j*T3[11]+1j*T3[14]))))))+(V2[2]*( (P2[0]*( (P1[0]*( 1j*T3[14]+1j*T3[11]))+(P1[2]*( -1j*T3[3]-1j*T3[12]))))+(P2[1]*( (P1[1]*( -1j*T3[14]-1j*T3[11]))+(P1[2]*( 1j*T3[7]+1j*T3[13]))))))))))
    return V1
    
    
def VVT3_2(V2, T3, COUP, M1, W1):
    return VVT3_1(V2,T3,COUP,M1,W1)
