import wavefunctions
def FFS1C1_2(F1, S3, COUP, M2, W2):
    F2 = wavefunctions.WaveFunction(size=6)
    F2[4] = F1[4]-S3[1]
    F2[5] = F1[5]-S3[2]
    P2 = [complex(F2[4]).real, \
             complex(F2[5]).real, \
             complex(F2[5]).imag, \
             complex(F2[4]).imag]
    denom =1.0/(( (M2*( -M2+1j*W2))+( (P2[0]**2)-(P2[1]**2)-(P2[2]**2)-(P2[3]**2))))
    F2[0]= COUP*denom*1j*(F1[0]*S3[0]*M2)
    F2[1]= COUP*denom*1j*(F1[1]*S3[0]*M2)
    F2[2]= COUP*denom*(S3[0]*( (F1[1]*( 1j*P2[1]+P2[2]))+(F1[0]*( 1j*P2[0]+1j*P2[3]))))
    F2[3]= COUP*denom*(S3[0]*( (F1[0]*( 1j*P2[1]-P2[2]))+(F1[1]*( 1j*P2[0]-1j*P2[3]))))
    return F2
    
    