import wavefunctions
def FFS1_3(F1, F2, COUP, M3, W3):
    S3 = wavefunctions.WaveFunction(size=3)
    S3[1] = -F1[4]+F2[4]
    S3[2] = -F1[5]+F2[5]
    P3 = [-complex(S3[1]).real, \
            - complex(S3[2]).real, \
            - complex(S3[2]).imag, \
            - complex(S3[1]).imag]
    denom =1.0/(( (M3*( -M3+1j*W3))+( (P3[0]**2)-(P3[1]**2)-(P3[2]**2)-(P3[3]**2))))
    S3[0]= COUP*denom*( 1j*(F2[0]*F1[0])+1j*(F2[1]*F1[1]))
    return S3
    
    