import wavefunctions
def FFV4_2(F1, V3, COUP, M2, W2):
    F2 = wavefunctions.WaveFunction(size=6)
    F2[4] = F1[4]-V3[4]
    F2[5] = F1[5]-V3[5]
    P2 = [complex(F2[4]).real, \
             complex(F2[5]).real, \
             complex(F2[5]).imag, \
             complex(F2[4]).imag]
    denom =1.0/(( (M2*( -M2+1j*W2))+( (P2[0]**2)-(P2[1]**2)-(P2[2]**2)-(P2[3]**2))))
    F2[0]= COUP*denom*( (F1[0]*( (P2[0]*( 1j*V3[0]+1j*V3[3]))+( (P2[1]*( -1j*V3[1]+V3[2]))+( (P2[2]*( -V3[1]-1j*V3[2]))+(P2[3]*( -1j*V3[0]-1j*V3[3]))))))+( (F1[1]*( (P2[0]*( 1j*V3[1]+V3[2]))+( (P2[1]*( -1j*V3[0]+1j*V3[3]))+( (P2[2]*( -V3[0]+V3[3]))+(P2[3]*( -1j*V3[1]-V3[2]))))))+(M2*( (F1[2]*( -1j*V3[0]+1j*V3[3]))+(F1[3]*( 1j*V3[1]+V3[2]))))))
    F2[1]= COUP*denom*( (F1[0]*( (P2[0]*( 1j*V3[1]-V3[2]))+( (P2[1]*( -1j*V3[0]-1j*V3[3]))+( (P2[2]*( V3[0]+V3[3]))+(P2[3]*( 1j*V3[1]-V3[2]))))))+( (F1[1]*( (P2[0]*( 1j*V3[0]-1j*V3[3]))+( (P2[1]*( -1j*V3[1]-V3[2]))+( (P2[2]*( V3[1]-1j*V3[2]))+(P2[3]*( 1j*V3[0]-1j*V3[3]))))))+(M2*( (F1[2]*( 1j*V3[1]-V3[2]))+(F1[3]*( -1j*V3[0]-1j*V3[3]))))))
    F2[2]= COUP*denom*( (F1[2]*( (P2[0]*( -1j*V3[0]+1j*V3[3]))+( (P2[1]*( 1j*V3[1]-V3[2]))+( (P2[2]*( V3[1]+1j*V3[2]))+(P2[3]*( -1j*V3[0]+1j*V3[3]))))))+( (F1[3]*( (P2[0]*( 1j*V3[1]+V3[2]))+( (P2[1]*( -1j*V3[0]-1j*V3[3]))+( (P2[2]*( -V3[0]-V3[3]))+(P2[3]*( 1j*V3[1]+V3[2]))))))+(M2*( (F1[0]*( 1j*V3[0]+1j*V3[3]))+(F1[1]*( 1j*V3[1]+V3[2]))))))
    F2[3]= COUP*denom*( (F1[2]*( (P2[0]*( 1j*V3[1]-V3[2]))+( (P2[1]*( -1j*V3[0]+1j*V3[3]))+( (P2[2]*( V3[0]-V3[3]))+(P2[3]*( -1j*V3[1]+V3[2]))))))+( (F1[3]*( (P2[0]*( -1j*V3[0]-1j*V3[3]))+( (P2[1]*( 1j*V3[1]+V3[2]))+( (P2[2]*( -V3[1]+1j*V3[2]))+(P2[3]*( 1j*V3[0]+1j*V3[3]))))))+(M2*( (F1[0]*( 1j*V3[1]-V3[2]))+(F1[1]*( 1j*V3[0]-1j*V3[3]))))))
    return F2
    
    