import wavefunctions
def VSS1_3(V1, S2, COUP, M3, W3):
    S3 = wavefunctions.WaveFunction(size=3)
    S3[1] = V1[4]+S2[1]
    S3[2] = V1[5]+S2[2]
    P2 = [complex(S2[1]).real, \
             complex(S2[2]).real, \
             complex(S2[2]).imag, \
             complex(S2[1]).imag]
    P3 = [-complex(S3[1]).real, \
            - complex(S3[2]).real, \
            - complex(S3[2]).imag, \
            - complex(S3[1]).imag]
    denom =1.0/(( (M3*( -M3+1j*W3))+( (P3[0]**2)-(P3[1]**2)-(P3[2]**2)-(P3[3]**2))))
    S3[0]= COUP*denom*(S2[0]*( (V1[0]*( -1j*P3[0]+1j*P2[0]))+( (V1[1]*( 1j*P3[1]-1j*P2[1]))+( (V1[2]*( 1j*P3[2]-1j*P2[2]))+(V1[3]*( 1j*P3[3]-1j*P2[3]))))))
    return S3
    
    