import wavefunctions
def VVVV1_2(V1, V3, V4, COUP, M2, W2):
    V2 = wavefunctions.WaveFunction(size=6)
    V2[4] = V1[4]+V3[4]+V4[4]
    V2[5] = V1[5]+V3[5]+V4[5]
    P2 = [-complex(V2[4]).real, \
            - complex(V2[5]).real, \
            - complex(V2[5]).imag, \
            - complex(V2[4]).imag]
    OM2 = 0.0
    if (M2): OM2=1.0/M2**2
    denom =1.0/(( (M2*( -M2+1j*W2))+( (P2[0]**2)-(P2[1]**2)-(P2[2]**2)-(P2[3]**2))))
    V2[0]= COUP*denom*( (OM2*( (V4[0]*( (P2[0]*( 1j*(V3[1]*V1[1])+1j*(V3[2]*V1[2])+1j*(V3[3]*V1[3])))+(V1[0]*( -1j*(V3[1]*P2[1])-1j*(V3[2]*P2[2])-1j*(V3[3]*P2[3])))))+( (V4[1]*( (P2[1]*( 1j*(V3[0]*V1[0])-1j*(V3[2]*V1[2])-1j*(V3[3]*V1[3])))+(V1[1]*( -1j*(V3[0]*P2[0])+1j*(V3[2]*P2[2])+1j*(V3[3]*P2[3])))))+( (V4[2]*( (P2[2]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[3]*V1[3])))+(V1[2]*( -1j*(V3[0]*P2[0])+1j*(V3[1]*P2[1])+1j*(V3[3]*P2[3])))))+(V4[3]*( (P2[3]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[2]*V1[2])))+(V1[3]*( -1j*(V3[0]*P2[0])+1j*(V3[1]*P2[1])+1j*(V3[2]*P2[2]))))))))*P2[0])+( (V4[0]*( -1j*(V3[1]*V1[1])-1j*(V3[2]*V1[2])-1j*(V3[3]*V1[3])))+(V3[0]*( 1j*(V4[1]*V1[1])+1j*(V4[2]*V1[2])+1j*(V4[3]*V1[3])))))
    V2[1]= COUP*denom*( (OM2*( (V4[0]*( (P2[0]*( 1j*(V3[1]*V1[1])+1j*(V3[2]*V1[2])+1j*(V3[3]*V1[3])))+(V1[0]*( -1j*(V3[1]*P2[1])-1j*(V3[2]*P2[2])-1j*(V3[3]*P2[3])))))+( (V4[1]*( (P2[1]*( 1j*(V3[0]*V1[0])-1j*(V3[2]*V1[2])-1j*(V3[3]*V1[3])))+(V1[1]*( -1j*(V3[0]*P2[0])+1j*(V3[2]*P2[2])+1j*(V3[3]*P2[3])))))+( (V4[2]*( (P2[2]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[3]*V1[3])))+(V1[2]*( -1j*(V3[0]*P2[0])+1j*(V3[1]*P2[1])+1j*(V3[3]*P2[3])))))+(V4[3]*( (P2[3]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[2]*V1[2])))+(V1[3]*( -1j*(V3[0]*P2[0])+1j*(V3[1]*P2[1])+1j*(V3[2]*P2[2]))))))))*P2[1])+( (V4[1]*( 1j*(V3[0]*V1[0])-1j*(V3[2]*V1[2])-1j*(V3[3]*V1[3])))+(V3[1]*( -1j*(V4[0]*V1[0])+1j*(V4[2]*V1[2])+1j*(V4[3]*V1[3])))))
    V2[2]= COUP*denom*( (OM2*( (V4[0]*( (P2[0]*( 1j*(V3[1]*V1[1])+1j*(V3[2]*V1[2])+1j*(V3[3]*V1[3])))+(V1[0]*( -1j*(V3[1]*P2[1])-1j*(V3[2]*P2[2])-1j*(V3[3]*P2[3])))))+( (V4[1]*( (P2[1]*( 1j*(V3[0]*V1[0])-1j*(V3[2]*V1[2])-1j*(V3[3]*V1[3])))+(V1[1]*( -1j*(V3[0]*P2[0])+1j*(V3[2]*P2[2])+1j*(V3[3]*P2[3])))))+( (V4[2]*( (P2[2]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[3]*V1[3])))+(V1[2]*( -1j*(V3[0]*P2[0])+1j*(V3[1]*P2[1])+1j*(V3[3]*P2[3])))))+(V4[3]*( (P2[3]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[2]*V1[2])))+(V1[3]*( -1j*(V3[0]*P2[0])+1j*(V3[1]*P2[1])+1j*(V3[2]*P2[2]))))))))*P2[2])+( (V4[2]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[3]*V1[3])))+(V3[2]*( -1j*(V4[0]*V1[0])+1j*(V4[1]*V1[1])+1j*(V4[3]*V1[3])))))
    V2[3]= COUP*denom*( (OM2*( (V4[0]*( (P2[0]*( 1j*(V3[1]*V1[1])+1j*(V3[2]*V1[2])+1j*(V3[3]*V1[3])))+(V1[0]*( -1j*(V3[1]*P2[1])-1j*(V3[2]*P2[2])-1j*(V3[3]*P2[3])))))+( (V4[1]*( (P2[1]*( 1j*(V3[0]*V1[0])-1j*(V3[2]*V1[2])-1j*(V3[3]*V1[3])))+(V1[1]*( -1j*(V3[0]*P2[0])+1j*(V3[2]*P2[2])+1j*(V3[3]*P2[3])))))+( (V4[2]*( (P2[2]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[3]*V1[3])))+(V1[2]*( -1j*(V3[0]*P2[0])+1j*(V3[1]*P2[1])+1j*(V3[3]*P2[3])))))+(V4[3]*( (P2[3]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[2]*V1[2])))+(V1[3]*( -1j*(V3[0]*P2[0])+1j*(V3[1]*P2[1])+1j*(V3[2]*P2[2]))))))))*P2[3])+( (V4[3]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[2]*V1[2])))+(V3[3]*( -1j*(V4[0]*V1[0])+1j*(V4[1]*V1[1])+1j*(V4[2]*V1[2])))))
    return V2
    
    