import wavefunctions
def VVVV1_3(V1, V2, V4, COUP, M3, W3):
    V3 = wavefunctions.WaveFunction(size=6)
    V3[4] = V1[4]+V2[4]+V4[4]
    V3[5] = V1[5]+V2[5]+V4[5]
    P3 = [-complex(V3[4]).real, \
            - complex(V3[5]).real, \
            - complex(V3[5]).imag, \
            - complex(V3[4]).imag]
    OM3 = 0.0
    if (M3): OM3=1.0/M3**2
    denom =1.0/(( (M3*( -M3+1j*W3))+( (P3[0]**2)-(P3[1]**2)-(P3[2]**2)-(P3[3]**2))))
    V3[0]= COUP*denom*( (OM3*( (V4[0]*( (V2[0]*( 1j*(V1[1]*P3[1])+1j*(V1[2]*P3[2])+1j*(V1[3]*P3[3])))+(V1[0]*( -1j*(V2[1]*P3[1])-1j*(V2[2]*P3[2])-1j*(V2[3]*P3[3])))))+( (V4[1]*( (V2[1]*( 1j*(V1[0]*P3[0])-1j*(V1[2]*P3[2])-1j*(V1[3]*P3[3])))+(V1[1]*( -1j*(V2[0]*P3[0])+1j*(V2[2]*P3[2])+1j*(V2[3]*P3[3])))))+( (V4[2]*( (V2[2]*( 1j*(V1[0]*P3[0])-1j*(V1[1]*P3[1])-1j*(V1[3]*P3[3])))+(V1[2]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[3]*P3[3])))))+(V4[3]*( (V2[3]*( 1j*(V1[0]*P3[0])-1j*(V1[1]*P3[1])-1j*(V1[2]*P3[2])))+(V1[3]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[2]*P3[2]))))))))*P3[0])+( (V1[0]*( -1j*(V4[1]*V2[1])-1j*(V4[2]*V2[2])-1j*(V4[3]*V2[3])))+(V2[0]*( 1j*(V4[1]*V1[1])+1j*(V4[2]*V1[2])+1j*(V4[3]*V1[3])))))
    V3[1]= COUP*denom*( (OM3*( (V4[0]*( (V2[0]*( 1j*(V1[1]*P3[1])+1j*(V1[2]*P3[2])+1j*(V1[3]*P3[3])))+(V1[0]*( -1j*(V2[1]*P3[1])-1j*(V2[2]*P3[2])-1j*(V2[3]*P3[3])))))+( (V4[1]*( (V2[1]*( 1j*(V1[0]*P3[0])-1j*(V1[2]*P3[2])-1j*(V1[3]*P3[3])))+(V1[1]*( -1j*(V2[0]*P3[0])+1j*(V2[2]*P3[2])+1j*(V2[3]*P3[3])))))+( (V4[2]*( (V2[2]*( 1j*(V1[0]*P3[0])-1j*(V1[1]*P3[1])-1j*(V1[3]*P3[3])))+(V1[2]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[3]*P3[3])))))+(V4[3]*( (V2[3]*( 1j*(V1[0]*P3[0])-1j*(V1[1]*P3[1])-1j*(V1[2]*P3[2])))+(V1[3]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[2]*P3[2]))))))))*P3[1])+( (V1[1]*( 1j*(V4[0]*V2[0])-1j*(V4[2]*V2[2])-1j*(V4[3]*V2[3])))+(V2[1]*( -1j*(V4[0]*V1[0])+1j*(V4[2]*V1[2])+1j*(V4[3]*V1[3])))))
    V3[2]= COUP*denom*( (OM3*( (V4[0]*( (V2[0]*( 1j*(V1[1]*P3[1])+1j*(V1[2]*P3[2])+1j*(V1[3]*P3[3])))+(V1[0]*( -1j*(V2[1]*P3[1])-1j*(V2[2]*P3[2])-1j*(V2[3]*P3[3])))))+( (V4[1]*( (V2[1]*( 1j*(V1[0]*P3[0])-1j*(V1[2]*P3[2])-1j*(V1[3]*P3[3])))+(V1[1]*( -1j*(V2[0]*P3[0])+1j*(V2[2]*P3[2])+1j*(V2[3]*P3[3])))))+( (V4[2]*( (V2[2]*( 1j*(V1[0]*P3[0])-1j*(V1[1]*P3[1])-1j*(V1[3]*P3[3])))+(V1[2]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[3]*P3[3])))))+(V4[3]*( (V2[3]*( 1j*(V1[0]*P3[0])-1j*(V1[1]*P3[1])-1j*(V1[2]*P3[2])))+(V1[3]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[2]*P3[2]))))))))*P3[2])+( (V1[2]*( 1j*(V4[0]*V2[0])-1j*(V4[1]*V2[1])-1j*(V4[3]*V2[3])))+(V2[2]*( -1j*(V4[0]*V1[0])+1j*(V4[1]*V1[1])+1j*(V4[3]*V1[3])))))
    V3[3]= COUP*denom*( (OM3*( (V4[0]*( (V2[0]*( 1j*(V1[1]*P3[1])+1j*(V1[2]*P3[2])+1j*(V1[3]*P3[3])))+(V1[0]*( -1j*(V2[1]*P3[1])-1j*(V2[2]*P3[2])-1j*(V2[3]*P3[3])))))+( (V4[1]*( (V2[1]*( 1j*(V1[0]*P3[0])-1j*(V1[2]*P3[2])-1j*(V1[3]*P3[3])))+(V1[1]*( -1j*(V2[0]*P3[0])+1j*(V2[2]*P3[2])+1j*(V2[3]*P3[3])))))+( (V4[2]*( (V2[2]*( 1j*(V1[0]*P3[0])-1j*(V1[1]*P3[1])-1j*(V1[3]*P3[3])))+(V1[2]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[3]*P3[3])))))+(V4[3]*( (V2[3]*( 1j*(V1[0]*P3[0])-1j*(V1[1]*P3[1])-1j*(V1[2]*P3[2])))+(V1[3]*( -1j*(V2[0]*P3[0])+1j*(V2[1]*P3[1])+1j*(V2[2]*P3[2]))))))))*P3[3])+( (V1[3]*( 1j*(V4[0]*V2[0])-1j*(V4[1]*V2[1])-1j*(V4[2]*V2[2])))+(V2[3]*( -1j*(V4[0]*V1[0])+1j*(V4[1]*V1[1])+1j*(V4[2]*V1[2])))))
    return V3
    
    