import wavefunctions
def VVVV1_4(V1, V2, V3, COUP, M4, W4):
    V4 = wavefunctions.WaveFunction(size=6)
    V4[4] = V1[4]+V2[4]+V3[4]
    V4[5] = V1[5]+V2[5]+V3[5]
    P4 = [-complex(V4[4]).real, \
            - complex(V4[5]).real, \
            - complex(V4[5]).imag, \
            - complex(V4[4]).imag]
    OM4 = 0.0
    if (M4): OM4=1.0/M4**2
    denom =1.0/(( (M4*( -M4+1j*W4))+( (P4[0]**2)-(P4[1]**2)-(P4[2]**2)-(P4[3]**2))))
    V4[0]= COUP*denom*( (OM4*( (V3[0]*( (V1[0]*( 1j*(V2[1]*P4[1])+1j*(V2[2]*P4[2])+1j*(V2[3]*P4[3])))+(V2[0]*( -1j*(V1[1]*P4[1])-1j*(V1[2]*P4[2])-1j*(V1[3]*P4[3])))))+( (V3[1]*( (V1[1]*( 1j*(V2[0]*P4[0])-1j*(V2[2]*P4[2])-1j*(V2[3]*P4[3])))+(V2[1]*( -1j*(V1[0]*P4[0])+1j*(V1[2]*P4[2])+1j*(V1[3]*P4[3])))))+( (V3[2]*( (V1[2]*( 1j*(V2[0]*P4[0])-1j*(V2[1]*P4[1])-1j*(V2[3]*P4[3])))+(V2[2]*( -1j*(V1[0]*P4[0])+1j*(V1[1]*P4[1])+1j*(V1[3]*P4[3])))))+(V3[3]*( (V1[3]*( 1j*(V2[0]*P4[0])-1j*(V2[1]*P4[1])-1j*(V2[2]*P4[2])))+(V2[3]*( -1j*(V1[0]*P4[0])+1j*(V1[1]*P4[1])+1j*(V1[2]*P4[2]))))))))*P4[0])+( (V2[0]*( -1j*(V3[1]*V1[1])-1j*(V3[2]*V1[2])-1j*(V3[3]*V1[3])))+(V1[0]*( 1j*(V3[1]*V2[1])+1j*(V3[2]*V2[2])+1j*(V3[3]*V2[3])))))
    V4[1]= COUP*denom*( (OM4*( (V3[0]*( (V1[0]*( 1j*(V2[1]*P4[1])+1j*(V2[2]*P4[2])+1j*(V2[3]*P4[3])))+(V2[0]*( -1j*(V1[1]*P4[1])-1j*(V1[2]*P4[2])-1j*(V1[3]*P4[3])))))+( (V3[1]*( (V1[1]*( 1j*(V2[0]*P4[0])-1j*(V2[2]*P4[2])-1j*(V2[3]*P4[3])))+(V2[1]*( -1j*(V1[0]*P4[0])+1j*(V1[2]*P4[2])+1j*(V1[3]*P4[3])))))+( (V3[2]*( (V1[2]*( 1j*(V2[0]*P4[0])-1j*(V2[1]*P4[1])-1j*(V2[3]*P4[3])))+(V2[2]*( -1j*(V1[0]*P4[0])+1j*(V1[1]*P4[1])+1j*(V1[3]*P4[3])))))+(V3[3]*( (V1[3]*( 1j*(V2[0]*P4[0])-1j*(V2[1]*P4[1])-1j*(V2[2]*P4[2])))+(V2[3]*( -1j*(V1[0]*P4[0])+1j*(V1[1]*P4[1])+1j*(V1[2]*P4[2]))))))))*P4[1])+( (V2[1]*( 1j*(V3[0]*V1[0])-1j*(V3[2]*V1[2])-1j*(V3[3]*V1[3])))+(V1[1]*( -1j*(V3[0]*V2[0])+1j*(V3[2]*V2[2])+1j*(V3[3]*V2[3])))))
    V4[2]= COUP*denom*( (OM4*( (V3[0]*( (V1[0]*( 1j*(V2[1]*P4[1])+1j*(V2[2]*P4[2])+1j*(V2[3]*P4[3])))+(V2[0]*( -1j*(V1[1]*P4[1])-1j*(V1[2]*P4[2])-1j*(V1[3]*P4[3])))))+( (V3[1]*( (V1[1]*( 1j*(V2[0]*P4[0])-1j*(V2[2]*P4[2])-1j*(V2[3]*P4[3])))+(V2[1]*( -1j*(V1[0]*P4[0])+1j*(V1[2]*P4[2])+1j*(V1[3]*P4[3])))))+( (V3[2]*( (V1[2]*( 1j*(V2[0]*P4[0])-1j*(V2[1]*P4[1])-1j*(V2[3]*P4[3])))+(V2[2]*( -1j*(V1[0]*P4[0])+1j*(V1[1]*P4[1])+1j*(V1[3]*P4[3])))))+(V3[3]*( (V1[3]*( 1j*(V2[0]*P4[0])-1j*(V2[1]*P4[1])-1j*(V2[2]*P4[2])))+(V2[3]*( -1j*(V1[0]*P4[0])+1j*(V1[1]*P4[1])+1j*(V1[2]*P4[2]))))))))*P4[2])+( (V2[2]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[3]*V1[3])))+(V1[2]*( -1j*(V3[0]*V2[0])+1j*(V3[1]*V2[1])+1j*(V3[3]*V2[3])))))
    V4[3]= COUP*denom*( (OM4*( (V3[0]*( (V1[0]*( 1j*(V2[1]*P4[1])+1j*(V2[2]*P4[2])+1j*(V2[3]*P4[3])))+(V2[0]*( -1j*(V1[1]*P4[1])-1j*(V1[2]*P4[2])-1j*(V1[3]*P4[3])))))+( (V3[1]*( (V1[1]*( 1j*(V2[0]*P4[0])-1j*(V2[2]*P4[2])-1j*(V2[3]*P4[3])))+(V2[1]*( -1j*(V1[0]*P4[0])+1j*(V1[2]*P4[2])+1j*(V1[3]*P4[3])))))+( (V3[2]*( (V1[2]*( 1j*(V2[0]*P4[0])-1j*(V2[1]*P4[1])-1j*(V2[3]*P4[3])))+(V2[2]*( -1j*(V1[0]*P4[0])+1j*(V1[1]*P4[1])+1j*(V1[3]*P4[3])))))+(V3[3]*( (V1[3]*( 1j*(V2[0]*P4[0])-1j*(V2[1]*P4[1])-1j*(V2[2]*P4[2])))+(V2[3]*( -1j*(V1[0]*P4[0])+1j*(V1[1]*P4[1])+1j*(V1[2]*P4[2]))))))))*P4[3])+( (V2[3]*( 1j*(V3[0]*V1[0])-1j*(V3[1]*V1[1])-1j*(V3[2]*V1[2])))+(V1[3]*( -1j*(V3[0]*V2[0])+1j*(V3[1]*V2[1])+1j*(V3[2]*V2[2])))))
    return V4
    
    